package com.zcloud.zcGbsServicer.web;

import com.alibaba.cola.dto.MultiResponse;
import com.alibaba.cola.dto.PageResponse;
import com.alibaba.cola.dto.Response;
import com.alibaba.cola.dto.SingleResponse;
import com.jjb.saas.framework.auth.model.SSOUser;
import com.jjb.saas.framework.auth.utils.AuthContext;
import com.zcloud.zcGbsServicer.api.ControlRoomServiceI;
import com.zcloud.zcGbsServicer.dto.ControlRoomAddCmd;
import com.zcloud.zcGbsServicer.dto.ControlRoomPageQry;
import com.zcloud.zcGbsServicer.dto.ControlRoomScreenQry;
import com.zcloud.zcGbsServicer.dto.ControlRoomUpdateCmd;
import com.zcloud.zcGbsServicer.dto.clientobject.ControlRoomCO;
import com.zcloud.zcGbsServicer.dto.clientobject.ControlRoomScreenCO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;

/**
 * web-adapter
 * @Author makejava
 * @Date 2026-01-21 17:21:47
 */
@Api(tags = "消防控制室")
@RequestMapping("/${application.gateway}/controlRoom")
@RestController
@AllArgsConstructor
public class ControlRoomController {
    private final ControlRoomServiceI controlRoomService;

    @ApiOperation("新增")
    @PostMapping("/save")
    public SingleResponse<ControlRoomCO> add(@Validated @RequestBody ControlRoomAddCmd cmd) {
        SSOUser ssoUser = AuthContext.getCurrentUser();
        return controlRoomService.add(cmd);
    }

    @ApiOperation("分页")
    @PostMapping("/list")
    @PreAuthorize("@pms.hasAnyPermission('xjkzs')")
    public PageResponse<ControlRoomCO> page(@RequestBody ControlRoomPageQry qry) {
        return controlRoomService.listPage(qry);
    }

    @ApiOperation("所有数据")
    @GetMapping("/listAll")
    public MultiResponse<ControlRoomCO> listAll() {
        return MultiResponse.of(new ArrayList<ControlRoomCO>());
    }

    @ApiOperation("详情")
    @GetMapping("/{id}")
    public SingleResponse<ControlRoomCO> getInfoById(@PathVariable("id") Long id) {
        return SingleResponse.of(controlRoomService.getInfoById(id));
    }

    @ApiOperation("删除")
    @DeleteMapping("/{id}")
    public Response remove(@PathVariable("id") Long id) {
        controlRoomService.remove(id);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("批量删除")
    @DeleteMapping("/ids")
    public Response removeBatch(@RequestParam Long[] ids) {
        controlRoomService.removeBatch(ids);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("修改")
    @PutMapping("/edit")
    public SingleResponse edit(@Validated @RequestBody ControlRoomUpdateCmd controlRoomUpdateCmd) {
        controlRoomService.edit(controlRoomUpdateCmd);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("可视化大屏-消防控制室查询")
    @PostMapping("/screenList")
    public PageResponse<ControlRoomScreenCO> screenList(@RequestBody ControlRoomScreenQry qry) {
        return controlRoomService.listScreen(qry);
    }
}
